<?php

// Load Dolibase
include_once '../autoload.php';

// Load Dolibase SetupPage class
dolibase_include_once('/core/pages/setup.php');

// Load other requirements
require_once DOL_DOCUMENT_ROOT . '/core/class/events.class.php';

// Create Setup Page using Dolibase
$page = new SetupPage('Audit', '$user->admin', false, false);

// Init objects
global $db;

$securityevent = new Events($db);

// Get parameters
$action = GETPOST('action', 'alpha');

// Set actions ---

// Enable Audit

if ($action == 'enable')
{
	global $conf;

	$events = array(
		'USER_LOGIN',
		'USER_LOGOUT',
		'USER_NEW_PASSWORD'
	);

	foreach ($events as $event) {
		$event_name = 'MAIN_LOGEVENTS_'.$event;
		dolibarr_set_const($db, $event_name, '1', 'chaine', 0, '', $conf->entity);
	}

	dolibase_redirect($_SERVER['PHP_SELF']);
}

// Disable Audit

else if ($action == 'disable')
{
	global $conf;

	foreach ($securityevent->eventstolog as $key => $arr) {
		$event_name = 'MAIN_LOGEVENTS_'.$arr['id'];
		dolibarr_del_const($db, $event_name, $conf->entity);
	}

	dolibase_redirect($_SERVER['PHP_SELF']);
}

// --- End actions

$page->addCssFile('common.css');

$page->addTab('Security', 'securemydolibarr/admin/security.php?mainmenu=home');

$page->addTab('AccessControl', 'securemydolibarr/admin/access.php?mainmenu=home');

$page->addTab('Audit', 'securemydolibarr/admin/audit.php?mainmenu=home', true);

$page->addTab('Backup', 'securemydolibarr/admin/backup.php?mainmenu=home');

$page->addTab('About', 'securemydolibarr/admin/about.php?mainmenu=home');

$page->begin();

$page->addSubtitle('Audit', 'audit.png@securemydolibarr');

$page->showTemplate('audit.php');

$page->end();
