<?php

// Load Dolibase
include_once '../autoload.php';

// Load Dolibase SetupPage class
dolibase_include_once('/core/pages/setup.php');

// Load Dolibase QueryBuilder class
dolibase_include_once('/core/class/query_builder.php');

// Create Setup Page using Dolibase
$page = new SetupPage('Backup', '$user->admin', false, false);

// Get parameters
$action = GETPOST('action', 'alpha');

// Set actions ---

// Enable Backup CRON

if ($action == 'enable')
{
	global $conf;

	if (! $conf->cron->enabled) {
		activateModule('modCron');
	}

	QueryBuilder::getInstance()->update('cronjob', array('status' => 1))->where("methodename = 'dumpDatabase'")->execute();

	dolibase_redirect($_SERVER['PHP_SELF']);
}

// Disable Backup CRON

else if ($action == 'disable')
{
	QueryBuilder::getInstance()->update('cronjob', array('status' => 0))->where("methodename = 'dumpDatabase'")->execute();

	dolibase_redirect($_SERVER['PHP_SELF']);
}

// --- End actions

$page->addCssFile('common.css');

$page->addTab('Security', 'securemydolibarr/admin/security.php?mainmenu=home');

$page->addTab('AccessControl', 'securemydolibarr/admin/access.php?mainmenu=home');

$page->addTab('Audit', 'securemydolibarr/admin/audit.php?mainmenu=home');

$page->addTab('Backup', 'securemydolibarr/admin/backup.php?mainmenu=home', true);

$page->addTab('About', 'securemydolibarr/admin/about.php?mainmenu=home');

$page->begin();

$page->addSubtitle('Backup', 'backup.png@securemydolibarr');

$page->showTemplate('backup.php');

$page->end();
