<?php

/* Copyright (C) 2017 Nicolas ZABOURI <info@inovea-conseil.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *   \file       htdocs/admin/vatmargin_setupapage.php
 *   \ingroup    v
 *   \brief      Page to setup module vatmargin
 */

$res = 0;
if (!$res && file_exists("../main.inc.php"))
    $res = @include '../main.inc.php';     // to work if your module directory is into dolibarr root htdocs directory
if (!$res && file_exists("../../main.inc.php"))
    $res = @include '../../main.inc.php';   // to work if your module directory is into a subdir of root htdocs directory
if (!$res && file_exists("../../../main.inc.php"))
    $res = @include '../../../main.inc.php';   // to work if your module directory is into a subdir of root htdocs directory
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php"))
    $res = @include '../../../dolibarr/htdocs/main.inc.php';     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include '../../../../dolibarr/htdocs/main.inc.php';   // Used on dev env only
if (!$res)
    die("Include of main fails");

require_once DOL_DOCUMENT_ROOT . '/core/lib/admin.lib.php';
require_once DOL_DOCUMENT_ROOT . '/core/class/doleditor.class.php';


require_once'../lib/vatmargin.lib.php';

$langs->load("admin");
$langs->load("vatmargin@vatmargin");

if (!$user->admin)
    accessforbidden();

$action = GETPOST("action");


/*
 * 	Actions
 */
global $langs;
if ($action == 'setvalue' && $user->admin) {
    $result = dolibarr_set_const($db, "VATMARGIN_ON_TVA_20", GETPOST("VATMARGIN_ON_TVA_20"), 'chaine', 0, '', $conf->entity);
    $result = dolibarr_set_const($db, "VATMARGIN_ON_TVA_10", GETPOST("VATMARGIN_ON_TVA_10"), 'chaine', 0, '', $conf->entity);
    $result = dolibarr_set_const($db, "VATMARGIN_ON_TVA_5", GETPOST("VATMARGIN_ON_TVA_5"), 'chaine', 0, '', $conf->entity);
    $result = dolibarr_set_const($db, "VATMARGIN_USE_FOR", GETPOST("VATMARGIN_USE_FOR"), 'chaine', 0, '', $conf->entity);
    $result = dolibarr_set_const($db, "VATMARGIN_REMOVE_EDIT_EXTRAFIELDS", GETPOST("VATMARGIN_REMOVE_EDIT_EXTRAFIELDS"), 'int', 0, '', $conf->entity);
    $result = dolibarr_set_const($db, "VATMARGIN_HIDE_VAT_ON_PDF", GETPOST("VATMARGIN_HIDE_VAT_ON_PDF"), 'int', 0, '', $conf->entity);
    if ($result >= 0) {
        setEventMessage($langs->trans("ModifWin"));
    } else {
        setEventMessage($langs->trans("Error"), 'errors');
    }
}


/*
 * View
 */

$arrayofparameters=array(
    'VATMARGIN_REMOVE_EDIT_EXTRAFIELDS'=>array('css'=>'minwidth200','type' => checkbox, 'enabled'=>1, 'val'=>1),
    'VATMARGIN_HIDE_VAT_ON_PDF'=>array('css'=>'minwidth200','type' => checkbox, 'enabled'=>1, 'val'=>1),
);


$wikihelp = 'EN:Module_vatmargin_En|FR:Module_vatmargin|ES:Módulo_vatmargin_Es';
llxHeader('', $langs->trans("vatmarginSetup"), $wikihelp);

$linkback = '<a href="' . DOL_URL_ROOT . '/admin/modules.php">' . $langs->trans("BackToModuleList") . '</a>';
print load_fiche_titre($langs->trans("vatmarginSetup"), $linkback, 'setup');

// Configuration header
$head = vatmarginPrepareHead();
dol_fiche_head($head, 'settings', '', -1, "vatmargin@vatmargin");

print $langs->trans("vatmarginDesc") . "<br>\n";

print '<br>';
$form = new Form($db);

print "<form method=\"post\" action=\"" . $_SERVER["PHP_SELF"] . "\">";
print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
print '<input type="hidden" name="action" value="setvalue">';
print '<table class="noborder" width="100%">';
print '<tr class="liste_titre">';
print '<td width="120" colspan="3">' . $langs->trans("Parametre") . '</td>';
print "</tr>\n";

print '<tr><td width="15%" valign="top">';
print $langs->trans("VATMARGIN_ON_TVA_5") . '%</td>';
print "<td width='15%'><input name='VATMARGIN_ON_TVA_5' size='15%' value='" . $conf->global->VATMARGIN_ON_TVA_5."'></td><td width='60%' align='left'>";

print $form->textwithpicto('', $htmltooltip, 1, 0) . '</td></tr>';
print '<tr><td width="15%" valign="top">';
print $langs->trans("VATMARGIN_ON_TVA_10") . '%</td>';
print "<td width='15%'><input name='VATMARGIN_ON_TVA_10' size='15%' value='" . $conf->global->VATMARGIN_ON_TVA_10."'></td><td width='60%' align='left'>";

print $form->textwithpicto('', $htmltooltip, 1, 0) . '</td></tr>';
print '<tr><td width="15%" valign="top">';
print $langs->trans("VATMARGIN_ON_TVA_20") . '%</td>';
print "<td width='15%'><input name='VATMARGIN_ON_TVA_20' size='15%' value='" . $conf->global->VATMARGIN_ON_TVA_20."'></td><td width='60%' align='left'>";

print $form->textwithpicto('', $htmltooltip, 1, 0) . '</td></tr>';

print '<tr><td width="15%" valign="top">';
print $langs->trans("VATMARGIN_USE_FOR") . '</td>';
print "<td width='15%'>".FORM::selectarray('VATMARGIN_USE_FOR', array('VATMARGIN_OCCASE', 'VATMARGIN_COLLEC','VATMARGIN_ART'), $conf->global->VATMARGIN_USE_FOR, 0, 0, 1, 'value="' . $conf->global->VATMARGIN_USE_FOR . '"', 1)."</td><td width='60%' align='left'>";

print $form->textwithpicto('', $htmltooltip, 1, 0) . '</td></tr>';

foreach($arrayofparameters as $key => $val)
{
    print '<tr class="oddeven"><td>';
    $tooltiphelp = (($langs->trans($key.'Tooltip') != $key.'Tooltip') ? $langs->trans($key.'Tooltip') : '');
    print $form->textwithpicto($langs->trans($key), $tooltiphelp);
    print '</td><td>';
    switch ($val['type']) {
        case 'checkbox' :

            print '<input type="hidden" name="'.$key.'"  class="flat" value="0" >';
            print '<input type="checkbox" name="'.$key.'"  class="flat" value="'. $val['val'] . '"' . ($conf->global->$key == $val['val'] ? 'checked="checked"' : '') . '>';
            break;

        default:
            print '<input name="'.$key.'"  class="flat '.(empty($val['css'])?'minwidth200':$val['css']).'" value="' . $conf->global->$key . '">';
    }
    if ($key == "VATMARGIN_REMOVE_EDIT_EXTRAFIELDS") {
        print '</td><td>' . $langs->trans('VATMARGIN_EXPLAIN_OF_EXTRA_NOT_EDITABLE') . '</td></tr>';
    } else {
        print '</td><td></td></tr>';
    }
}
print $form->textwithpicto('', $htmltooltip, 1, 0) . '</td></tr>';
print '</table>';

print '<center><br><input type="submit" class="button" value="' . $langs->trans("Modifier") . '"></center>';

print '</form><br><br>';

// Page end
dol_fiche_end();
llxFooter();

$db->close();
