<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of actions_vatmargin
 *
 * @author stagiaire
 */
class ActionsVatmargin
{

    /**
     * @var DoliDB Database handler.
     */
    public $db;

    /**
     * @var string Error code (or message)
     */
    public $error = '';

    /**
     * @var array Errors
     */
    public $errors = array();

    /**
     * @var array Hook results. Propagated to $hookmanager->resArray for later reuse
     */
    public $results = array();

    /**
     * @var string String displayed by executeHook() immediately after return
     */
    public $resprints;

    /**
     * Constructor
     *
     *  @param		DoliDB		$db      Database handler
     */
    public function __construct($db)
    {
        $this->db = $db;
    }

    /**
     *
     * @global object $langs
     * @global object $outputlangs
     * @global object $db
     * @global object $mysoc
     * @global object $conf
     * @global object $user
     * @param type $parameters
     * @param type $pdfclass
     * @param type $action
     * @param type $hookmanager
     * @return int
     */
    public function beforePDFCreation($parameters, &$object, &$action)
    {
        global $langs, $outputlangs, $db, $mysoc, $conf, $user;

        if ((int) DOL_VERSION < 9) {
            if (($action == 'builddoc' || $action == 'confirm_valid' || $action == 'confirm_validate' || $action == 'addline' || $action == 'updateligne') && $parameters['object']) {
                $object = $parameters['object'];
                $outputlangs->load('vatmargin@vatmargin');
                if (($object->element == 'propal' || $object->element == 'facture' || $object->element == 'commande') && $object->array_options['options_vatmargin'] == 2) {
                    if ($conf->global->VATMARGIN_HIDE_VAT_ON_PDF) {
                        foreach ($parameters['object']->lines as $line) {
                            $line->total_ht = $line->total_ttc;
                            $line->multicurrency_total_ht = $line->multicurrency_total_ttc;
                        }
                        $object->total_ht = $object->total_ttc;

                        $conf->global->MAIN_GENERATE_DOCUMENTS_WITHOUT_VAT_COLUMN = 1;
                        $conf->global->MAIN_GENERATE_DOCUMENTS_WITHOUT_VAT = 1;

                        $outputlangs->tab_translate['TotalHT'] = "Total TTC";
                    }
                    $outputlangs->tab_translate['VATIsNotUsedForInvoice'] = $outputlangs->trans('VATMARGIN_ARTICLE_FOR_PDF') . ' ' . $outputlangs->transnoentities($conf->global->VATMARGIN_USE_FOR);
                }
            }
        } else {
           // print '<pre>'.print_r($object,1).'</pre>';
            if (($action == 'builddoc' || $action == 'confirm_valid' || $action == 'confirm_validate' || $action == 'addline' || $action == 'updateline') && $parameters['object']) {
               // $object = $parameters['object'];
                //$outputlangs->load('vatmargin@vatmargin');
                $langs->load('vatmargin@vatmargin');
                if (($object->element == 'propal' || $object->element == 'facture' || $object->element == 'commande') && $object->array_options['options_vatmargin'] == 2) {
                    if ($conf->global->VATMARGIN_HIDE_VAT_ON_PDF) {
                        foreach ($object->lines as $line) {
                            $line->total_ht = $line->total_ttc;
                            $line->multicurrency_total_ht = $line->multicurrency_total_ttc;
                        }
                        $object->total_ht = $object->total_ttc;

                        $conf->global->MAIN_GENERATE_DOCUMENTS_WITHOUT_VAT_COLUMN = 1;
                        $conf->global->MAIN_GENERATE_DOCUMENTS_WITHOUT_VAT = 1;

                        $langs->tab_translate['TotalHT'] = "Total TTC";
                    }
                    $langs->tab_translate['VATIsNotUsedForInvoice'] = $langs->trans('VATMARGIN_ARTICLE_FOR_PDF') . ' ' . $langs->transnoentities($conf->global->VATMARGIN_USE_FOR);
                    $outputlangs->tab_translate['VATIsNotUsedForInvoice'] = $langs->tab_translate['VATIsNotUsedForInvoice'];
                }
            }
            //print '<pre>'.print_r($langs->tab_translate['VATIsNotUsedForInvoice'],1).'</pre>';
        }
        //$outputlangs->tab_translate['TotalHT'] = "Total TTC";
        if ($object->array_options['options_vatmargin'] == 2) {
            $langs->tab_translate['PriceUHT'] = "P.U. TTC";
        }

        $this->resprints = '';
        return 0;
    }

    /**
     * Execute action
     *
     * @param	array	$parameters     Array of parameters
     * @param   Object	$pdfhandler     PDF builder handler
     * @param   string	$action         'add', 'update', 'view'
     * @return  int 		            <0 if KO,
     *                                  =0 if OK but we want to process standard actions too,
     *                                  >0 if OK and we want to replace standard actions.
     */
    public function afterPDFCreation($parameters, &$pdfhandler, &$action)
    {
        global $conf, $user, $langs;
        global $hookmanager;

        if ($conf->global->VATMARGIN_HIDE_VAT_ON_PDF) {
            $conf->global->MAIN_GENERATE_DOCUMENTS_WITHOUT_VAT_COLUMN = 0;
            $conf->global->MAIN_GENERATE_DOCUMENTS_WITHOUT_VAT = 0;
        }

        return 0;
    }

    /**
     *
     * @global object $langs
     * @global object $db
     * @global object $mysoc
     * @global object $conf
     * @global object $user
     * @param type $parameters
     * @param type $object
     * @param type $action
     * @param type $hookmanager
     */
    public function doActions($parameters, &$object, &$action, $hookmanager)
    {
        global $langs, $db, $mysoc, $conf, $user;

        //refresh de la page pour afficher les bonnes valeur en haut à droite, que ça soit pour la marge ou les totaux

        if ((int) DOL_VERSION < 9) {
            if ($action == 'builddoc' || $action == 'confirm_valid' || $action == 'confirm_validate' || $action == 'addline' || $action == 'updateligne') {
                if (($object->element == 'propal' || $object->element == 'facture' || $object->element == 'commande') && $object->array_options['options_vatmargin'] == 2) {
                    $mysoc->tva_assuj = false;
                    $mysoc->country_code = 'FR';
                    print "<script type=\"text/javascript\">
                        jQuery(document).ready(function() {
                            JQuery(\"tr\").each(function(){
                                var a_href = $('td.right').find('a').attr('href');
                                alert (\"Href is: \" + a_href);
                            });
                        });
                    </script>";
                }
            }
        } else {
            if ($action == 'builddoc' || $action == 'confirm_valid' || $action == 'confirm_validate' || $action == 'addline' || $action == 'updateline') {
                if (($object->element == 'propal' || $object->element == 'facture' || $object->element == 'commande') && $object->array_options['options_vatmargin'] == 2) {
                    $mysoc->tva_assuj = false;
                    $mysoc->country_code = 'FR';
                }
            }
        }
    }

    function formObjectOptions($parameters, $object, $action)
    {
        global $conf, $db, $langs, $user;

        if ($object->array_options['options_vatmargin'] == 2) {
            $langs->load("other");
            //Dans le cas d'une insertion ou d'une mise à jour de ligne, le montant des marges et des totaux, dans la partie droite de la fiche, ne se met pas de suite à jour. On actualise la page pour que ça se produise.
            print '<script type="text/javascript">  
            if(window.location.href.includes("#addline")){
                window.location.href = window.location.href.replace("#addline","");
            }
            if(window.location.href.includes("#line_'.GETPOST("lineid").'")){
                window.location.href = window.location.href.replace("#line_'.GETPOST("lineid").'","");
            }
            
            
        </script>';
            print "<script type=\"text/javascript\">
                jQuery(document).ready(function() {
                    jQuery(\".linecoluht\").first().html('P.U. TTC');
                });
                
                jQuery(document).ready(function() {
                    jQuery(\"#price_ttc\").parent().remove();
                    jQuery(\"td:contains('" . $langs->trans("PriceUTTC") . "')\").remove();
                    jQuery(\".linecoluttc\").remove();
                });
            </script>";
        }

        if (($object->element == 'propal' || $object->element == 'facture' || $object->element == 'commande') && $conf->global->VATMARGIN_REMOVE_EDIT_EXTRAFIELDS) {
            print "<script type=\"text/javascript\">
                jQuery(document).ready(function() {
                    jQuery(\"td\").each(function(){
                        var a = jQuery( this ).find('a');
                        if (typeof a.attr('href') != 'undefined') { 
                            if (a.attr('href').indexOf('vatmargin') !== -1){
                                a.remove();
                            } 
                        }
                    });
                });
            </script>";
        }
    }

    function formAddObjectLine($parameters, $object, $action)
    {
        global $conf, $db, $langs, $user;


        if ($object->array_options['options_vatmargin'] == 2) {
            print "<script type=\"text/javascript\">
                jQuery(document).ready(function() {
                    jQuery(\".linecoluht\").first().html('P.U. TTC');
                });
            </script>";
        }
    }

    function createFrom($parameters, $object, $action)
    {
        global $user, $conf;

        if ($conf->vatmargin->enabled && $object->array_options['options_vatmargin']) {
            unset($object->context['createfromclone']);
            $this->db->commit();

            if (count($object->lines) == 0) {
                return;
            }

            switch ($object->element) {
                case 'propal':
                    $propalCloned = new Propal($this->db);
                    $propalCloned->fetch($object->lines[0]->fk_propal);

                    $propal = new Propal($this->db);
                    $propal->fetch($object->id);

                    foreach ($propal->lines as $key => $line) {
                        $line->marge_tx = $propalCloned->lines[$key]->marge_tx;
                        $line->marque_tx = $propalCloned->lines[$key]->marque_tx;

                        $line->subprice = $propalCloned->lines[$key]->subprice;
                        $line->price = $propalCloned->lines[$key]->price;

                        $line->pa_ht = $propalCloned->lines[$key]->pa_ht;
                        $line->total_ht = $propalCloned->lines[$key]->total_ht;
                        $line->total_tva = $propalCloned->lines[$key]->total_tva;
                        $line->total_ttc = $propalCloned->lines[$key]->total_ttc+$propalCloned->lines[$key]->total_tva;

                        $line->multicurrency_subprice = $propalCloned->lines[$key]->multicurrency_subprice;
                        $line->multicurrency_total_ht = $propalCloned->lines[$key]->multicurrency_total_ht;
                        $line->multicurrency_total_tva = $propalCloned->lines[$key]->multicurrency_total_tva;
                        $line->multicurrency_total_ttc = $propalCloned->lines[$key]->multicurrency_total_ttc;

                        $line->localtax1_tx = $propalCloned->lines[$key]->localtax1_tx;
                        $line->localtax2_tx = $propalCloned->lines[$key]->localtax2_tx;
                        $line->localtax1_type = $propalCloned->lines[$key]->localtax1_type;
                        $line->localtax2_type = $propalCloned->lines[$key]->localtax2_type;
                        $line->total_localtax1 = $propalCloned->lines[$key]->total_localtax1;
                        $line->total_localtax2 = $propalCloned->lines[$key]->total_localtax2;

                        $line->update(1);
                    }

                    $propal->total_ht = $propalCloned->total_ht;
                    $propal->total_tva = $propalCloned->total_tva;
                    $propal->total_ttc = $propalCloned->total_ttc;
                    $propal->total = $propalCloned->total;

                    $propal->multicurrency_total_ht = $propalCloned->multicurrency_total_ht;
                    $propal->multicurrency_total_tva = $propalCloned->multicurrency_total_tva;
                    $propal->multicurrency_total_ttc = $propalCloned->multicurrency_total_ttc;

                    $propal->total_localtax1 = $propalCloned->total_localtax1;
                    $propal->total_localtax2 = $propalCloned->total_localtax2;

                    $propal->update($user);
                    break;
                case 'commande':
                    $orderCloned = new Commande($this->db);
                    $orderCloned->fetch($object->lines[0]->fk_commande);

                    $order = new Commande($this->db);
                    $order->fetch($object->id);

                    foreach ($order->lines as $key => $line) {
                        $line->marge_tx = $orderCloned->lines[$key]->marge_tx;
                        $line->marque_tx = $orderCloned->lines[$key]->marque_tx;

                        $line->subprice = $orderCloned->lines[$key]->subprice;
                        $line->price = $orderCloned->lines[$key]->price;

                        $line->pa_ht = $orderCloned->lines[$key]->pa_ht;
                        $line->total_ht = $orderCloned->lines[$key]->total_ht;
                        $line->total_tva = $orderCloned->lines[$key]->total_tva;
                        $line->total_ttc = $orderCloned->lines[$key]->total_ttc+$orderCloned->lines[$key]->total_tva;

                        $line->multicurrency_subprice = $orderCloned->lines[$key]->multicurrency_subprice;
                        $line->multicurrency_total_ht = $orderCloned->lines[$key]->multicurrency_total_ht;
                        $line->multicurrency_total_tva = $orderCloned->lines[$key]->multicurrency_total_tva;
                        $line->multicurrency_total_ttc = $orderCloned->lines[$key]->multicurrency_total_ttc;

                        $line->localtax1_tx = $orderCloned->lines[$key]->localtax1_tx;
                        $line->localtax2_tx = $orderCloned->lines[$key]->localtax2_tx;
                        $line->localtax1_type = $orderCloned->lines[$key]->localtax1_type;
                        $line->localtax2_type = $orderCloned->lines[$key]->localtax2_type;
                        $line->total_localtax1 = $orderCloned->lines[$key]->total_localtax1;
                        $line->total_localtax2 = $orderCloned->lines[$key]->total_localtax2;

                        $line->update($user, 1);
                    }

                    $order->total_ht = $orderCloned->total_ht;
                    $order->total_tva = $orderCloned->total_tva;
                    $order->total_ttc = $orderCloned->total_ttc;
                    $order->total = $orderCloned->total;

                    $order->multicurrency_total_ht = $orderCloned->multicurrency_total_ht;
                    $order->multicurrency_total_tva = $orderCloned->multicurrency_total_tva;
                    $order->multicurrency_total_ttc = $orderCloned->multicurrency_total_ttc;

                    $order->total_localtax1 = $orderCloned->total_localtax1;
                    $order->total_localtax2 = $orderCloned->total_localtax2;

                    $order->update($user);
                    break;
            }
        }
    }
}
